%bcond_without		uclibc
%define Werror_cflags	%{nil} 
%define _ssp_cflags	%{nil}

Summary:	Multi-call binary combining many common Unix tools into one executable
Name:		busybox
Version:	1.16.0
Release:	%mkrel 2
Epoch:		1
License:	GPL
Group:		Shells
URL:		http://www.busybox.net/
Source0:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2
Source1:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2.sign
Source2:	busybox-1.15.2-config
Source3:	busybox-1.15.2-minimal-config
#Patch0:	busybox-1.12.1-static.patch
Patch1:		busybox-i.15.2-no-march_i386.patch
Patch12:	busybox-1.2.2-ls.patch
Patch16:	busybox-1.10.1-hwclock.patch
BuildRequires:	gcc >= 3.3.1-2mdk
%if %{with uclibc}
BuildRequires:	uClibc-static-devel >= 0.9.26-5mdk
%define __cc	%{uclibc_cc}
%define	cflags	%{uclibc_cflags}
%else
BuildRequires:	glibc-static-devel
%define	cflags	%{optflags}
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable. It provides minimalist replacements for most
of the utilities you usually find in GNU coreutils, shellutils, etc.
The utilities in BusyBox generally have fewer options than their
full-featured GNU cousins; however, the options that are included provide
the expected functionality and behave very much like their GNU counterparts.
BusyBox provides a fairly complete POSIX environment for any small or
embedded system.

BusyBox has been written with size-optimization and limited resources in
mind. It is also extremely modular so you can easily include or exclude
commands (or features) at compile time. This makes it easy to customize
your embedded systems. To create a working system, just add /dev, /etc,
and a kernel.

%package	static
Group:		Shells
Summary:	Static linked busybox

%description	static
This package contains a static linked busybox.

%prep
%setup -q
#%%patch0 -b .static -p1
%patch1 -b .no_march~ -p1
%patch12 -b .ls~ -p1
%patch16 -b .ia64~ -p1

%build
cat %{SOURCE2} |sed \
	-e 's|^.*CONFIG_EXTRA_CFLAGS.*$|CONFIG_EXTRA_CFLAGS="%{cflags} -fno-strict-aliasing"|g' \
	> .config
yes "" | %make oldconfig V=1
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1
mv busybox_unstripped busybox.full.static
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1 CONFIG_STATIC=n
mv busybox_unstripped busybox.full


%if %{with uclibc}
cat %{SOURCE3} |sed \
	-e 's|^.*CONFIG_EXTRA_CFLAGS.*$|CONFIG_EXTRA_CFLAGS="%{cflags} -fno-strict-aliasing"|g' \
	> .config
yes "" | %make oldconfig V=1
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1
mv busybox_unstripped busybox.minimal.static
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1 CONFIG_STATIC=n
mv busybox_unstripped busybox.minimal
%endif

%check
# FIXME
%if 0
%make CC=%{__cc} V=1 check
%endif

%install
rm -rf %{buildroot}
install -m755 busybox.full -D %{buildroot}%{_bindir}/busybox
install -m755 busybox.full.static -D %{buildroot}/bin/busybox.static
%if %{with uclibc}
install -m755 busybox.minimal -D %{buildroot}%{uclibc_root}%{_bindir}/busybox.minimal
install -m755 busybox.minimal.static -D %{buildroot}%{uclibc_root}/bin/busybox.minimal.static
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc AUTHORS README TODO
%{_bindir}/busybox
%if %{with uclibc}
%{uclibc_root}%{_bindir}/busybox.minimal
%endif

%files static
%defattr(-,root,root)
%doc AUTHORS README TODO
/bin/busybox.static
%if %{with uclibc}
%{uclibc_root}/bin/busybox.minimal.static
%endif


%changelog
* Tue Feb 09 2010 Eugeni Dodonov <eugeni@mandriva.com> 1:1.16.0-2mdv2010.1
+ Revision: 502912
- Enable new mkfs.ext2 plugin.

* Thu Feb 04 2010 Eugeni Dodonov <eugeni@mandriva.com> 1:1.16.0-1mdv2010.1
+ Revision: 500869
- Add missing signature file.
- Update to 1.16.0.
  Rediff P12.

* Thu Dec 17 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 1:1.15.3-1mdv2010.1
+ Revision: 479817
- new release: 1.15.3
- enable CONFIG_FINDFS for minimal config (usable by mkinitrd)
- build both static & dynamic binaries
- don't disable -debug package with uclibc
- build a minimal busybox.minimal binary for use with mkinitrd
- hush: Enable support for local variables in functions.
- drop busybox.links from docs, same can be achieved with 'busybox --install'...
- update configuration
- don't disable EJECT with glibc, misunderstandting due to missing headers on my part..
- use new %%{uclibc_cc} macro

* Mon Nov 30 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 1:1.15.2-2mdv2010.1
+ Revision: 471727
- update to work with new libified uclibc
- don't build deprecated msh shell
- don't force -march=i386 on x86 (P1)
- disable stack protector when building against uclibc
- disable CONFIG_EJECT if building against glibc (header breakage)
- make sure that  we don't try to use uclibc gcc wrapper when linking against
  static glibc
- disable debug packages if linking against uclibc
- fix proper prefix for uclibc gcc wrapper
- build with %%{optflags} & %%{ldflags}
- statically link against uClibc again (now on all platforms as well)

* Tue Nov 10 2009 Eugeni Dodonov <eugeni@mandriva.com> 1:1.15.2-1mdv2010.1
+ Revision: 464108
- Updated to 1.15.2.
  Drop P14 (msh is no more).

* Thu Aug 13 2009 Pascal Terjan <pterjan@mandriva.org> 1:1.14.3-2mdv2010.0
+ Revision: 416027
- Update config (so that we get back things like lsmod/rmmod/working modprobe)

* Wed Aug 12 2009 Frederik Himpe <fhimpe@mandriva.org> 1:1.14.3-1mdv2010.0
+ Revision: 415670
- update to new version 1.14.3

* Fri Jun 26 2009 Eugeni Dodonov <eugeni@mandriva.com> 1:1.14.2-1mdv2010.0
+ Revision: 389334
- Updated to 1.14.2

* Thu Jun 11 2009 Eugeni Dodonov <eugeni@mandriva.com> 1:1.14.1-1mdv2010.0
+ Revision: 385186
- Updated to 1.14.1

* Sun Mar 22 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:1.13.3-1mdv2009.1
+ Revision: 360094
- Updated to version 1.13.3

* Tue Jan 27 2009 Jérôme Soyer <saispo@mandriva.org> 1:1.13.2-1mdv2009.1
+ Revision: 334151
- New upstream release

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild early 2009.0 package (before pixel changes)

* Fri May 16 2008 Oden Eriksson <oeriksson@mandriva.com> 1:1.6.1-5mdv2009.0
+ Revision: 208121
- added P2 in an attempt to fix #40789

* Tue Mar 25 2008 Per Øyvind Karlsen <peroyvind@mandriva.org> 1:1.6.1-4mdv2008.1
+ Revision: 189835
- build unlzma
- dump full paths for busybox function wrappers to busybox.list and package it
  as it may come in handy

* Wed Jan 02 2008 Olivier Blin <oblin@mandriva.com> 1:1.6.1-3mdv2008.1
+ Revision: 140691
- restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Sep 12 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:1.6.1-3mdv2008.0
+ Revision: 84638
- Enable loadkmap and dumpkmap, needed for example when setting up a
  initrd for luks encrypted root and you need to change keyboard layout
  etc. to type passwords, from Rapha?\195?\171l Gertz <rapsys@free.fr>.

* Fri Aug 31 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:1.6.1-2mdv2008.0
+ Revision: 76912
- Fixed build with uClibc.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - update description

* Wed Aug 22 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:1.6.1-1mdv2008.0
+ Revision: 68750
- Updated to version 1.6.1, with available official patches.

* Fri Jun 08 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:1.5.1-3mdv2008.0
+ Revision: 37519
- Disabled deprecated DEVFSD support, as reported by Olivier Blin on
  cooker ML.
- Rename busybox-1.5.1.config to busybox.config, cosmetic change to
  avoid rename of file between each version update causing diff to
  be "lost" on svn diff output.

* Mon Jun 04 2007 Christiaan Welvaart <spturtle@mandriva.org> 1:1.5.1-2mdv2008.0
+ Revision: 35159
- do not use uClibc for ppc

* Wed May 23 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:1.5.1-1mdv2008.0
+ Revision: 30257
- Updated to 1.5.1.

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - build against uclibc on x86_64 too
    - drop 'make dep' as it's not needed anymore
    - forgot signature
    - new release: 1.4.2


* Wed Dec 13 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
+ 2006-12-13 21:37:32 (96563)
- use glibc for ppc build

* Wed Dec 13 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
+ 2006-12-13 21:31:42 (96560)
Import busybox

* Sat Apr 22 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.1.2-1mdk
- 1.1.2
- fix --with options

* Tue Apr 11 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.1.1-3mdk
- fix buildrequires

* Fri Apr 07 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.1.1-1mdk
- New release 1.1.1
- regenerate config
- better macro for uclibc

* Wed Sep 07 2005 Thierry Vignaud <tvignaud@mandriva.com> 1.01-2mdk
- fix build on x86_64

* Thu Sep 01 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.01-1mdk
- 1.01
- %%mkrel

* Wed Apr 27 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.00-3mdk
- don't use uclibc on sparc, seems to be broken

* Tue Mar 08 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.00-2mdk
- rebuild against new uClibc
- use cpu optimizations

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.00-1mdk
- 1.00
- regenerate config (S2)
- cosmetics

* Tue Jan 06 2004 Jaco Greeff <jaco@mandrake.org> 1.00-0.pre5.1mdk
- 1.00-pre5
- Re-generated config to cater for new options since pre4

